 package client;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

public class MessageClient implements Runnable {

	private String client_name;
	private String host_name;
	private int port;
	/*
	 * GUI
	 */
	MessageClientGui messageClientGui = null;
	/*
	 * SOCKET
	 */
	protected DataInputStream in;
	protected DataOutputStream out;
	protected Thread listener;
	private Socket sock;
	// Setze thread_run = false um den Thread zu beenden!
	boolean thread_run = true;

	public void guiAccess(MessageClientGui messageClientGui) {
		this.messageClientGui = messageClientGui;
	}

	
	public MessageClient(String clientName, String hostName, int iport) {

		client_name = clientName;
		host_name = hostName;
		port = iport;

		// Socket Initialisierung
		try {
			this.sock = new Socket(host_name, port);
			this.in = new DataInputStream(new BufferedInputStream(
					sock.getInputStream()));
			this.out = new DataOutputStream(new BufferedOutputStream(
					sock.getOutputStream()));

			// Registrierung sollte hier erfolgen!
			sendMessage(client_name + "is online!");

		} catch (IOException e) {
			System.err.println(e.toString());
			System.exit(1);
		}

		// Thread starten
		listener = new Thread(this);
		listener.start();
	}

	public void run() {
		try {

			while (thread_run) {

				// ...warten (blockierend) bis eine Nachricht eintrifft!
				String msg = in.readUTF();

				// Das eigentliche Protokoll für die Kommunikation erfolgt hier!

				if (messageClientGui != null)
					messageClientGui.setText(msg);

			}

		} catch (IOException ex) {
			ex.printStackTrace();
		} finally {

			try {
				in.close();
				out.close();
				sock.close();
			} catch (IOException ex) {
				ex.printStackTrace();
			}

		}

	}

	public void sendMessage(String msg) {

		try {
			out.writeUTF(msg);
			out.flush();

		} catch (IOException ex) {
			ex.printStackTrace();
			Thread.interrupted();
		}

	}

}
