package server;

/**
 * www.informatics4kids.de
 * Licence GPL - roehl@fsg-preetz.de
 * Der Server ist zuerst zu starten. Die Clients benötigen den Port und die
 * IP-Adresse der Servers, um sich mit dem Server verbinden zu können.
 */
import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;

public class MessageServer {

	// Jeder Client hat eine eindeutige ID
	public static int client_id = 0;
	public static int port_number = 4444;

	public static void main(String[] args) {
		// overwrite the default values
		if (args.length == 1)
			port_number = Integer.parseInt(args[0]);

		try {
			System.out.println("Waiting for connections on port " + port_number
					+ "...");
			ServerSocket serverSocket = new ServerSocket(port_number);
			while (true) {
				Socket socket = serverSocket.accept();
				(new MessageServerThread(client_id++, socket)).start();
			}
		} catch (IOException e) {
			System.err.println(e.toString());
			System.exit(1);
		}
	}
}
