package server;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;
import java.util.Vector;

class MessageServerThread extends Thread {

	private int name;

	private Socket socket;
	private DataInputStream in;
	private DataOutputStream out;

	// Alle Clients werden in dieser Liste registriert.
	protected static Vector<MessageServerThread> ls_client = new Vector<MessageServerThread>();

	public MessageServerThread(int name, Socket socket) {
		this.name = name;
		this.socket = socket;
		ls_client.addElement(this);
	}

	public void run() {

		String msg = "MessageServer: Connection " + name;
		System.out.println(msg + " now exists!");
		msg = "MessageServer: Currently " + ls_client.size() + " users online";
		System.out.println(msg);

		try {
			in = new DataInputStream(new BufferedInputStream(
					socket.getInputStream()));
			out = new DataOutputStream(new BufferedOutputStream(
					socket.getOutputStream()));

			while (true) {

				// Broadcast - Message:Sende Nachrichten immer an alle Clients.
				msg = in.readUTF();				
				for (int i = 0; i < ls_client.size(); i++) {
					MessageServerThread mst = (MessageServerThread) ls_client
							.elementAt(i);
					mst.out.writeUTF(msg);
					mst.out.flush();
				}

			}

		} catch (IOException e) {

			System.out.println("MessageServer: Connection " + name
					+ " is terminated");

			try {
				in.close();
				out.close();
				socket.close();
			} catch (IOException ex) {
				ex.printStackTrace();
			}

			int del_pos = 0;
			for (int i = 0; i < ls_client.size(); i++) {
				MessageServerThread mst = (MessageServerThread) ls_client
						.elementAt(i);
				if (mst.name == name) {
					del_pos = i;
					break;
				}
			}

			ls_client.remove(del_pos);

			msg = "MessageServer: Currently " + ls_client.size()
					+ " users online";
			System.out.println(msg);

		}

	}
}
